#include <mysql.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "dbconnect.h"

#if 1
#define SQLSIZE 524288
#else
#define SQLSIZE 200
#endif

void parse(int year) {
	char instr[1024];
	char query[SQLSIZE];
	char *curparam;
	char *intin, *srcip, *dstip, *proto, *spt, *dpt, *time, *monthstr, *day;
	int protonr, intnr, sptnr, dptnr, month;
	int len = 0;

	while(fgets(instr, 1024, stdin)) {
		//printf("%s", instr);

		monthstr = strtok(instr, " ");		// month
		day = strtok(NULL, " ");		// day
		time = strtok(NULL, " ");		// time
		strtok(NULL, " ");			// hostname

		if (!strncmp(monthstr, "Jan", 3))
			month = 1;
		else if (!strncmp(monthstr, "Feb", 3))
			month = 2;
		else if (!strncmp(monthstr, "Mar", 3))
			month = 3;
		else if (!strncmp(monthstr, "Apr", 3))
			month = 4;
		else if (!strncmp(monthstr, "May", 3))
			month = 5;
		else if (!strncmp(monthstr, "Jun", 3))
			month = 6;
		else if (!strncmp(monthstr, "Jul", 3))
			month = 7;
		else if (!strncmp(monthstr, "Aug", 3))
			month = 8;
		else if (!strncmp(monthstr, "Sep", 3))
			month = 9;
		else if (!strncmp(monthstr, "Oct", 3))
			month = 10;
		else if (!strncmp(monthstr, "Nov", 3))
			month = 11;
		else if (!strncmp(monthstr, "Dec", 3))
			month = 12;
		else
			printf("eek, trasig mnad: %s\n", monthstr);

		intin = NULL;
		srcip = NULL;
		dstip = NULL;
		proto = NULL;
		spt = NULL;
		dpt = NULL;
		while(curparam = strtok(NULL, " \n")) {
			if(!strncmp(curparam, "IN=", 3))
				intin = curparam + 3;
			else if(!strncmp(curparam, "SRC=", 4))
				srcip = curparam + 4;
			else if(!strncmp(curparam, "DST=", 4))
				dstip = curparam + 4;
			else if(!strncmp(curparam, "PROTO=", 6))
				proto = curparam + 6;
			else if(!strncmp(curparam, "SPT=", 4))
				spt = curparam + 4;
			else if(!strncmp(curparam, "DPT=", 4))
				dpt = curparam + 4;
			else if(!strncmp(curparam, "TYPE=", 5))
				spt = curparam + 5;
			else if(!strncmp(curparam, "CODE=", 5))
				dpt = curparam + 5;
		}

		if (!strcmp(proto, "TCP"))
			protonr = 6;
		else if (!strcmp(proto, "UDP"))
			protonr = 17;
		else if (!strcmp(proto, "ICMP"))
			protonr = 1;
		else
			protonr = 0;

		if (spt)
			sptnr = atoi(spt);
		else
			sptnr = 0;

		if (dpt)
			dptnr = atoi(dpt);
		else
			dptnr = 0;

		if(!strncmp(intin, "eth", 3))
			intnr = atoi(intin + 3);
		else
			intnr = 255;

		if (!len)
			len += sprintf(query+len, "INSERT INTO connlogs (time, interface, proto, srcip, dstip, spt, dpt, flags) values ");
		else
			len += sprintf(query+len, ",");

		len += sprintf(query+len, "('%04d-%02d-%s %s', %i, %i, %u, %u, %i, %i, 0)", year, month, day, time, intnr, protonr, ntohl(inet_addr(srcip)), ntohl(inet_addr(dstip)), sptnr, dptnr);
		if (len >= SQLSIZE-100) {
			db_insert(query);
			//printf("%s\n", query);
			len = 0;
		}
	}
}

int main(int argc, char *argv[]) {
	db_connect("logscan");

	parse(2004);

	db_close();
}
